#ifndef __FIELD__
#define __FIELD__

using XMLIOSERVER::XML::XMLNode;
using XMLIOSERVER::XML::THashAttributes;

namespace XMLIOSERVER
{
   class Field : public ObjectTemplate<Field>, public FieldAttribut
   {
      public:
      
         Field(void) : ObjectTemplate<Field>(), FieldAttribut()
			{/* Ne rien faire de plus */}	         	
			Field(const string& _id) : ObjectTemplate<Field>(_id), FieldAttribut()
         {/* Ne rien faire de plus */}	
         
         friend ostream& operator<< (ostream& out, const Field& c) 
         {
            out << IncIndent << "<" << c.getName();
            if(c.hasId()) out << " id=\"" <<  c.getId() << "\"";
            for(unsigned int i = 0; i < c.attrList.getVectorSize(); i++) out << *c.attrList.getVector()[i];
            out << "/>" << DecEndl;
                           
            return (out);
         }
         
         void setAttributes(const THashAttributes& _attr)
         {
            for (THashAttributes::ConstIterator it = _attr.begin(); it != _attr.end(); it++)
               if ((*it).first.compare(string("id")))
               // Non prise en compte de l'identifiant lors de l'affectation des attributs.
                  this->setSAttribut((*it).first, (*it).second);
         }
         
         void addAttributes(const StrHashMap<BaseAttribut>& _pattr)
         {
            StrHashMap<BaseAttribut>& _lattr = getAttributList();
            
            //_pattr contient les attributs du parent, _lattr les attributs locaux.
            
            for(unsigned int i = 0; i < _lattr.getVectorSize(); i++)
            {
               if(_lattr.getVector()[i]->_hasValue() or !_pattr.getVector()[i]->_hasValue()) continue;
               _lattr.getVector()[i]->assignValue(_pattr.getVector()[i]);
            }
         }
         
         const char* getName(void) const {return ("Field"); }   

			void parse (XMLNode& _node)
			{
            string name = _node.getElementName();            
            THashAttributes attributes;
            
            /// PARSING GESTION DES ATTRIBUTS ///
            _node.getAttributes(attributes);  
            this->setAttributes(attributes);
            attributes.clear();
            
            /// PARSING POUR GESION DES ENFANTS
            // Rien à faire.
            
            return;
         }
         
         ~Field(void) 
         { /* Ne rien faire de plus */ }    
      
   }; // class Field 
      
}; // namespace XMLIOSERVER
   
#endif // __FIELD__
